#include <bits/stdc++.h>

#define X first
#define Y second

using namespace std;



inline int rnd(int a, int b){
	return a + (rand() % (b-a+1));
}

vector<vector<int>> shuffle_graphs(vector<int> per, const vector<vector<vector<int>>> & graphs){
	vector<vector<int>> res(per.size());
	int offset = 0;
	for(auto e : graphs){
		int n = e.size();
		for(int i = 0; i < n; ++i){
			for(auto v : e[i]){
				res[per[offset+i]].push_back(per[offset+v]);
			}
		}

		offset += n;
	}

	return res;
}

vector<vector<int>> hairy_cycle(int n, int cycle_size, int hair_size){
	vector<vector<int>> res(n);
	for(int i = 0; i < cycle_size-1; ++i){
		res[i].push_back(i+1);
	}
	res[cycle_size-1].push_back(0);

	int i = cycle_size;
	while(i<n){
		for(int j = 0; j < hair_size-1 && i < n-1; ++i,++j){
			res[i].push_back(i+1);
		}
		res[i].push_back(rnd(0, cycle_size-1));
		++i;
	}
	return res;
}

vector<vector<int>> make_undirected(vector<vector<int>> g){
	int n = g.size();
	vector<set<int>> tmp(n);

	for(int i = 0; i < n; ++i){
		for(auto x : g[i]){
			tmp[i].insert(x);
			tmp[x].insert(i);
		}
	}
	vector<vector<int>> ret(n);

	for(int i = 0; i < n; ++i){
		for(auto x : tmp[i]){
			ret[i].push_back(x);
		}
	}


	return ret;
}


vector<vector<int>> make_directed(vector<vector<int>> g){ // g undirected
	int n = g.size();
	vector<vector<int>> ret(n);
	for(int i = 0; i < n; ++i){
		for(auto x : g[i]) if(x > i){
			ret[i].push_back(x);
		}
	}

	return ret;
}

vector<vector<int>> random_tree(int n){
	vector<vector<int>> res(n);
	for(int i = 1; i < n; ++i){
		res[i].push_back(rnd(0, i-1));
	}
	return res;
}

vector<vector<int>> random_connected(int n, int m){ // chceme m = O(n), jinak pomaly
	assert(m >= n-1);
	assert(m <= n*1ll*(n-1));
	vector<set<int>> ret(n);

	vector<vector<int>> sp_tree = random_tree(n);
	for(int i = 1; i < n; ++i) for(auto x : sp_tree[i]) ret[i].insert(x);

	m-=n-1;

	int a, b;
	while(m > 0){
		a = rnd(0, n-1);
		b = rnd(0, n-1);
		if(a == b || (ret[a].find(b)) != ret[a].end()) continue;
		ret[a].insert(b);
		--m;
	}

	vector<vector<int>> retv(n);

	for(int i = 0; i < n; ++i){
		for(auto x : ret[i]){
			retv[i].push_back(x);
		}
	}

	return retv;
}

int main(int argc, char ** argv){

	vector<string> args(argv+1, argv+argc);

	unsigned long seed = stoi(args[0]);
	srand(seed);

	int n = 0;
	vector<vector<vector<int>>> parts;

	int parts_n = stoi(args[1]);
	int pos = 2;


	stack<pair<int, int>> repeats;

	for(int i = 0; i < parts_n; ++i){
		char t = args[pos][0];
		char m = args[pos++][1];
		assert(t == 't' || t == 'd' || t == 'c' || t == 'r' || t == 'x');
		assert(m == '0' || m == 'u');
		vector<vector<int>> cur;
		int ni = stoi(args[pos++]);

		//cerr << t << " " << m << " " << ni << endl;

		if(t == 't'){
			cur = random_tree(ni);
			n+=ni;

		}

		if(t == 'd'){
			int mi = stoi(args[pos++]);
			cur = make_directed(make_undirected(random_connected(ni, mi)));
			n+=ni;

		}

		if(t == 'c'){
			int cs = stoi(args[pos++]);
			int hs = stoi(args[pos++]);
			cur = hairy_cycle(ni, cs, hs);
			n+=ni;

		}

		if(t == 'r'){
			int mi = stoi(args[pos++]);
			cur = random_connected(ni, mi);
			n+=ni;
		}

		if(t == 'x'){
			repeats.push({ni-1, pos});
			--i;
			continue;
		}


		if(m == 'u') cur = make_undirected(cur);
		parts.push_back(cur);

		if(!repeats.empty()){
			auto tp = repeats.top();
			repeats.pop();
			pos = tp.second;
			--i;
			if(--tp.first > 0) repeats.push(tp);
		}
	}


	vector<int> perm(n);
	for(int i = 0; i < n; ++i) perm[i]=i;
	random_shuffle(perm.begin(), perm.end());

	auto graph = shuffle_graphs(perm, parts);

	int m = 0;
	for(auto x : graph) m+=x.size();

	cout << n << " " << m << endl;

	for(int i = 0; i < n; ++i) for(auto x : graph[i]){
		cout << i+1 << " " << x+1 << endl;
	}


}