#include <iostream>
#include <vector>

using namespace std;

int n, m;
vector < vector < int > > G; // graf na vstupu
vector < vector < int > > Gr; // graf s opačnou orientací než G
vector < int > components; // index komponenty každého vrcholu
vector < int > indegree; // počet vcházejících hran každého vrcholu

void find_components(int u, int comp) { // hledání slabě souvislých komponent
  //cerr << "c  " << u << " " << comp << endl;
  if (components[u] != -1)
    return;

  components[u] = comp;

  for (auto v: G[u])
    find_components(v, comp);
  for (auto v: Gr[u])
    find_components(v, comp);
}

int main() {
  cin >> n >> m;
  G.resize(n), Gr.resize(n), indegree.resize(n, 0), components.resize(n, -1);


  for (int i = 0; i < m; ++i) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    G[u].push_back(v);
    Gr[v].push_back(u);
    ++indegree[v];
  }



  int numcomps = 0; // počet slabě souvislých komponent G
  for (int u = 0; u < n; ++u) {
    if (components[u] == -1) { // není-li v žádné dosud nalezené komponentě, projdeme ji
      //cerr << u << " " << numcomps << endl;
      find_components(u, numcomps);
      ++numcomps;
    }
  }


  vector < int > s; // zásobník vrcholů, do nichž již nevedou žádné hrany
  for (int u = 0; u < n; ++u) {
    if (Gr[u].empty()) {
      s.push_back(u);
    }
  }
  while (!s.empty()) { // postupně odstraňujeme vrcholy, do kterých již nevede hrana
    int u = s.back();
    s.pop_back();
    for (auto v: G[u]) {
      --indegree[v];
      if (indegree[v] == 0) {
        s.push_back(v);
      }
    }
  }


  vector < bool > acyclic(numcomps, true); // acyklické komponenty jsou nyní prázdné
  for (int u = 0; u < n; ++u) {
    if (indegree[u] > 0) {
      acyclic[components[u]] = false;
    }
  }

  int ans = n; // od počtu vrcholů odečteme počet acyklických komponent
  for (int i = 0; i < numcomps; ++i) {
    if (acyclic[i]) {
      --ans;
    }
  }

  cout << ans << endl;
}